/** @file cmdline.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.6
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef CMDLINE_H
#define CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
/** @brief the program name (used for printing errors) */
#define CMDLINE_PARSER_PACKAGE "proxyserver"
#endif

#ifndef CMDLINE_PARSER_PACKAGE_NAME
/** @brief the complete program name (used for help and version) */
#define CMDLINE_PARSER_PACKAGE_NAME "proxyserver"
#endif

#ifndef CMDLINE_PARSER_VERSION
/** @brief the program version */
#define CMDLINE_PARSER_VERSION "0.1"
#endif

/** @brief Where the command line options are stored */
struct gengetopt_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  int debug_flag;	/**< @brief Debug mode, a lot of information (default=off).  */
  const char *debug_help; /**< @brief Debug mode, a lot of information help description.  */
  int async_flag;	/**< @brief Async mode: don't wait real API server response (default=off).  */
  const char *async_help; /**< @brief Async mode: don't wait real API server response help description.  */
  int forbidden_flag;	/**< @brief Response as 403 Forbidden for each request (default=off).  */
  const char *forbidden_help; /**< @brief Response as 403 Forbidden for each request help description.  */
  char * local_address_arg;	/**< @brief Local bind address (default='0.0.0.0').  */
  char * local_address_orig;	/**< @brief Local bind address original value given at command line.  */
  const char *local_address_help; /**< @brief Local bind address help description.  */
  int local_port_arg;	/**< @brief Local bind port (default='8080').  */
  char * local_port_orig;	/**< @brief Local bind port original value given at command line.  */
  const char *local_port_help; /**< @brief Local bind port help description.  */
  char * remote_address_arg;	/**< @brief Remote server address (default='api.datadome.co').  */
  char * remote_address_orig;	/**< @brief Remote server address original value given at command line.  */
  const char *remote_address_help; /**< @brief Remote server address help description.  */
  char * remote_port_arg;	/**< @brief Remote server port (default='80').  */
  char * remote_port_orig;	/**< @brief Remote server port original value given at command line.  */
  const char *remote_port_help; /**< @brief Remote server port help description.  */
  int remote_timeout_arg;	/**< @brief Remote server timeout in ms (default='100').  */
  char * remote_timeout_orig;	/**< @brief Remote server timeout in ms original value given at command line.  */
  const char *remote_timeout_help; /**< @brief Remote server timeout in ms help description.  */
  int remote_reconnect_timeout_arg;	/**< @brief Remove server reconnect timeout in ms (default='30000').  */
  char * remote_reconnect_timeout_orig;	/**< @brief Remove server reconnect timeout in ms original value given at command line.  */
  const char *remote_reconnect_timeout_help; /**< @brief Remove server reconnect timeout in ms help description.  */
  int max_remote_connections_arg;	/**< @brief Maximum open connections to API server (default='8').  */
  char * max_remote_connections_orig;	/**< @brief Maximum open connections to API server original value given at command line.  */
  const char *max_remote_connections_help; /**< @brief Maximum open connections to API server help description.  */
  int max_messages_queue_length_arg;	/**< @brief Maximum queue size of messages to send to API server (default='10240').  */
  char * max_messages_queue_length_orig;	/**< @brief Maximum queue size of messages to send to API server original value given at command line.  */
  const char *max_messages_queue_length_help; /**< @brief Maximum queue size of messages to send to API server help description.  */
  int threads_arg;	/**< @brief Numbers of running threads (default='4').  */
  char * threads_orig;	/**< @brief Numbers of running threads original value given at command line.  */
  const char *threads_help; /**< @brief Numbers of running threads help description.  */
  char * client_id_arg;	/**< @brief Client id cookie name (default='datadome').  */
  char * client_id_orig;	/**< @brief Client id cookie name original value given at command line.  */
  const char *client_id_help; /**< @brief Client id cookie name help description.  */
  int ssl_flag;	/**< @brief Use SSL connection for API Server (default=off).  */
  const char *ssl_help; /**< @brief Use SSL connection for API Server help description.  */
  char * proxy_address_arg;	/**< @brief Proxy server address.  */
  char * proxy_address_orig;	/**< @brief Proxy server address original value given at command line.  */
  const char *proxy_address_help; /**< @brief Proxy server address help description.  */
  char * proxy_port_arg;	/**< @brief Port server port (default='3128').  */
  char * proxy_port_orig;	/**< @brief Port server port original value given at command line.  */
  const char *proxy_port_help; /**< @brief Port server port help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int debug_given ;	/**< @brief Whether debug was given.  */
  unsigned int async_given ;	/**< @brief Whether async was given.  */
  unsigned int forbidden_given ;	/**< @brief Whether forbidden was given.  */
  unsigned int local_address_given ;	/**< @brief Whether local_address was given.  */
  unsigned int local_port_given ;	/**< @brief Whether local_port was given.  */
  unsigned int remote_address_given ;	/**< @brief Whether remote_address was given.  */
  unsigned int remote_port_given ;	/**< @brief Whether remote_port was given.  */
  unsigned int remote_timeout_given ;	/**< @brief Whether remote_timeout was given.  */
  unsigned int remote_reconnect_timeout_given ;	/**< @brief Whether remote_reconnect_timeout was given.  */
  unsigned int max_remote_connections_given ;	/**< @brief Whether max_remote_connections was given.  */
  unsigned int max_messages_queue_length_given ;	/**< @brief Whether max_messages_queue_length was given.  */
  unsigned int threads_given ;	/**< @brief Whether threads was given.  */
  unsigned int client_id_given ;	/**< @brief Whether client_id was given.  */
  unsigned int ssl_given ;	/**< @brief Whether ssl was given.  */
  unsigned int proxy_address_given ;	/**< @brief Whether proxy_address was given.  */
  unsigned int proxy_port_given ;	/**< @brief Whether proxy_port was given.  */

} ;

/** @brief The additional parameters to pass to parser functions */
struct cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure gengetopt_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure gengetopt_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *gengetopt_args_info_purpose;
/** @brief the usage string of the program */
extern const char *gengetopt_args_info_usage;
/** @brief the description string of the program */
extern const char *gengetopt_args_info_description;
/** @brief all the lines making the help output */
extern const char *gengetopt_args_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser (int argc, char **argv,
  struct gengetopt_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use cmdline_parser_ext() instead
 */
int cmdline_parser2 (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_ext (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  struct cmdline_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_dump(FILE *outfile,
  struct gengetopt_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_file_save(const char *filename,
  struct gengetopt_args_info *args_info);

/**
 * Print the help
 */
void cmdline_parser_print_help(void);
/**
 * Print the version
 */
void cmdline_parser_print_version(void);

/**
 * Initializes all the fields a cmdline_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void cmdline_parser_params_init(struct cmdline_parser_params *params);

/**
 * Allocates dynamically a cmdline_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized cmdline_parser_params structure
 */
struct cmdline_parser_params *cmdline_parser_params_create(void);

/**
 * Initializes the passed gengetopt_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void cmdline_parser_init (struct gengetopt_args_info *args_info);
/**
 * Deallocates the string fields of the gengetopt_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void cmdline_parser_free (struct gengetopt_args_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int cmdline_parser_required (struct gengetopt_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* CMDLINE_H */
